package jp.hishidama.swing.table;

import java.awt.Dimension;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.RowSorter;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;

/**
 * swb_[JTable.
 *
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/tech/java/swing/JTable.html"
 *         >Ђ</a>
 * @since 2009.04.04
 * @version 2009.04.19 |bvAbvj[dataTableƓ̂g悤C
 * @version 2009.04.21 dataTableRowSorterォύXꂽꍇɑΉ
 */
public class RowHeaderTable extends JTable implements PropertyChangeListener {
	private static final long serialVersionUID = 5371347964805024090L;

	protected JTable dataTable;
	protected RowHeaderSortListener sortListener;

	/**
	 * swb_[e[u RXgN^[
	 *
	 * @param dataTable
	 *            f[^pJTable
	 * @param name
	 *            swb_[̗񌩏o
	 * @param width
	 *            swb_[̕
	 */
	public RowHeaderTable(JTable dataTable, String name, int width) {

		super(new RowHeaderDataModel(dataTable), null,
				new RowHeaderSelectionModel(dataTable));
		this.dataTable = dataTable;

		// B̗
		{
			TableColumn tc = new TableColumn(0, width);
			// Z̃_[
			DefaultTableCellRenderer r = new DefaultTableCellRenderer();
			r.setHorizontalAlignment(SwingConstants.CENTER);
			r.setBackground(this.getTableHeader().getBackground());
			tc.setCellRenderer(r);

			tc.setHeaderValue(name);
			tc.setResizable(false);
			addColumn(tc);
		}

		// wb_[
		{
			JTableHeader h = super.getTableHeader();
			// h.setEnabled(false);
			h.setReorderingAllowed(false);
			h.addMouseListener(new RowHeaderCHMouseListener(dataTable));
		}

		// \[^[
		sortListener = new RowHeaderSortListener(this);
		dataTable.addPropertyChangeListener("rowSorter", sortListener);
		RowSorter<? extends TableModel> sort = dataTable.getRowSorter();
		if (sort != null) {
			sort.addRowSorterListener(sortListener);
		}

		// |bvAbvj[
		propertyChange(null);
		dataTable.addPropertyChangeListener("componentPopupMenu", this);
	}

	/**
	 * JScrollPaneɓCX^Xo^B
	 *
	 * @param scroll
	 */
	public void installTo(JScrollPane scroll) {

		scroll.setRowHeaderView(this);

		scroll.setCorner(JScrollPane.UPPER_LEFT_CORNER, this.getTableHeader());

		Dimension sz = new Dimension(this.getPreferredSize().width, dataTable
				.getPreferredSize().height);
		scroll.getRowHeader().setPreferredSize(sz);
	}

	/** tH[JX̓f[^e[uɓnB */
	@Override
	public void requestFocus() {
		dataTable.requestFocus();
	}

	/** tH[JX̓f[^e[uɓnB */
	@Override
	public boolean requestFocus(boolean temporary) {
		return dataTable.requestFocus(temporary);
	}

	/** tH[JX̓f[^e[uɓnB */
	@Override
	public boolean requestFocusInWindow() {
		return dataTable.requestFocusInWindow();
	}

	// PropertyChangeListener

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		JPopupMenu pmenu = dataTable.getComponentPopupMenu();
		setComponentPopupMenu(pmenu);
	}
}
